Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/tranxt.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 2528)
@@ -15,44 +15,55 @@
    !!            3.0  !  2008-06  (G. Madec)  time stepping always done in trazdf
    !!            3.1  !  2009-02  (G. Madec, R. Benshila)  re-introduce the vvl option
-   !!----------------------------------------------------------------------
-
-   !!----------------------------------------------------------------------
-   !!   tra_nxt       : time stepping on temperature and salinity
-   !!   tra_nxt_fix   : time stepping on temperature and salinity : fixed    volume case
-   !!   tra_nxt_vvl   : time stepping on temperature and salinity : variable volume case
+   !!            3.3  !  2010-04  (M. Leclair, G. Madec)  semi-implicit hpg with asselin filter + modified LF-RA
+   !!             -   !  2010-05  (C. Ethe, G. Madec)  merge TRC-TRA
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   tra_nxt       : time stepping on tracers
+   !!   tra_nxt_fix   : time stepping on tracers : fixed    volume case
+   !!   tra_nxt_vvl   : time stepping on tracers : variable volume case
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables 
+   USE sbc_oce         ! surface boundary condition: ocean
    USE zdf_oce         ! ???
    USE domvvl          ! variable volume
    USE dynspg_oce      ! surface     pressure gradient variables
    USE dynhpg          ! hydrostatic pressure gradient 
-   USE trdmod_oce      ! ocean variables trends
-   USE trdmod          ! ocean active tracers trends 
+   USE trdmod_oce      ! ocean space and time domain variables 
+   USE trdtra          ! ocean active tracers trends 
    USE phycst
+   USE obc_oce
    USE obctra          ! open boundary condition (obc_tra routine)
-   USE bdytra          ! Unstructured open boundary condition (bdy_tra routine)
+   USE bdy_par         ! Unstructured open boundary condition (bdy_tra_frs routine)
+   USE bdytra          ! Unstructured open boundary condition (bdy_tra_frs routine)
    USE in_out_manager  ! I/O manager
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE prtctl          ! Print control
+   USE traqsr          ! penetrative solar radiation (needed for nksr)
+   USE traswp          ! swap array
+   USE obc_oce 
+#if defined key_agrif
    USE agrif_opa_update
    USE agrif_opa_interp
-   USE obc_oce 
+#endif
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   tra_nxt    ! routine called by step.F90
-
-   REAL(wp), DIMENSION(jpk) ::   r2dt_t   ! vertical profile time step, =2*rdttra (leapfrog) or =rdttra (Euler)
+   PUBLIC   tra_nxt       ! routine called by step.F90
+   PUBLIC   tra_nxt_fix   ! to be used in trcnxt
+   PUBLIC   tra_nxt_vvl   ! to be used in trcnxt
+
+   REAL(wp)                 ::   rbcp            ! Brown & Campana parameters for semi-implicit hpg
+   REAL(wp), DIMENSION(jpk) ::   r2dt   ! vertical profile time step, =2*rdttra (leapfrog) or =rdttra (Euler)
 
    !! * Substitutions
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
-   !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! NEMO/OPA 3.3 , NEMO-Consortium (2010) 
+   !! $Id $
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -81,11 +92,9 @@
       !!              - (ta,sa) time averaged (t,s)   (ln_dynhpg_imp = T)
       !!----------------------------------------------------------------------
-      USE oce, ONLY :    ztrdt => ua   ! use ua as 3D workspace   
-      USE oce, ONLY :    ztrds => va   ! use va as 3D workspace   
-      !!
       INTEGER, INTENT(in) ::   kt    ! ocean time-step index
       !!
-      INTEGER  ::   jk    ! dummy loop indices
-      REAL(wp) ::   zfact ! temporary scalars
+      INTEGER  ::   jk, jn    ! dummy loop indices
+      REAL(wp) ::   zfact     ! local scalars
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
       !!----------------------------------------------------------------------
 
@@ -94,60 +103,82 @@
          IF(lwp) WRITE(numout,*) 'tra_nxt : achieve the time stepping by Asselin filter and array swap'
          IF(lwp) WRITE(numout,*) '~~~~~~~'
+         !
+         rbcp    = 0.25 * (1. + atfp) * (1. + atfp) * ( 1. - atfp)       ! Brown & Campana parameter for semi-implicit hpg
       ENDIF
 
       ! Update after tracer on domain lateral boundaries
       ! 
-      CALL lbc_lnk( ta, 'T', 1. )      ! local domain boundaries  (T-point, unchanged sign)
-      CALL lbc_lnk( sa, 'T', 1. )
-      !
-#if defined key_obc
+      CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )      ! local domain boundaries  (T-point, unchanged sign)
+      CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )
+      !
+#if defined key_obc || defined key_bdy || defined key_agrif
+      CALL tra_unswap
+#endif
+
+#if defined key_obc 
       IF( lk_obc )   CALL obc_tra( kt )  ! OBC open boundaries
 #endif
-#if defined key_bdy
-      CALL bdy_tra( kt )               ! BDY open boundaries
+#if defined key_bdy 
+      IF( lk_bdy )   CALL bdy_tra_frs( kt )  ! BDY open boundaries
 #endif
 #if defined key_agrif
-      CALL Agrif_tra                   ! AGRIF zoom boundaries
+      CALL Agrif_tra                     ! AGRIF zoom boundaries
+#endif
+
+#if defined key_obc || defined key_bdy || defined key_agrif
+      CALL tra_swap
 #endif
  
       ! set time step size (Euler/Leapfrog)
-      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;   r2dt_t(:) =     rdttra(:)      ! at nit000             (Euler)
-      ELSEIF( kt <= nit000 + 1 )           THEN   ;   r2dt_t(:) = 2.* rdttra(:)      ! at nit000 or nit000+1 (Leapfrog)
+      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;   r2dt(:) =     rdttra(:)      ! at nit000             (Euler)
+      ELSEIF( kt <= nit000 + 1 )           THEN   ;   r2dt(:) = 2.* rdttra(:)      ! at nit000 or nit000+1 (Leapfrog)
       ENDIF
 
       ! trends computation initialisation
-      IF( l_trdtra ) THEN              ! store now fields before applying the Asselin filter
-         ztrdt(:,:,:) = tn(:,:,:)      
-         ztrds(:,:,:) = sn(:,:,:)
-      ENDIF
-
-      ! Leap-Frog + Asselin filter time stepping
-      IF( lk_vvl )   THEN   ;   CALL tra_nxt_vvl( kt )      ! variable volume level (vvl)
-      ELSE                  ;   CALL tra_nxt_fix( kt )      ! fixed    volume level
-      ENDIF
+      IF( l_trdtra )   THEN                    ! store now fields before applying the Asselin filter
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsn(:,:,:,jp_tem) 
+         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = tsn(:,:,:,jp_sal)
+      ENDIF
+
+      IF( neuler == 0 .AND. kt == nit000 ) THEN       ! Euler time-stepping at first time-step (only swap)
+         DO jn = 1, jpts
+            DO jk = 1, jpkm1
+               tsn(:,:,jk,jn) = tsa(:,:,jk,jn)    
+            END DO
+         END DO
+      ELSE                                            ! Leap-Frog + Asselin filter time stepping
+         !
+         IF( lk_vvl )  THEN   ;   CALL tra_nxt_vvl( kt, 'TRA', tsb, tsn, tsa, jpts )  ! variable volume level (vvl)     
+         ELSE                 ;   CALL tra_nxt_fix( kt, 'TRA', tsb, tsn, tsa, jpts )  ! fixed    volume level 
+         ENDIF
+      ENDIF 
 
 #if defined key_agrif
       ! Update tracer at AGRIF zoom boundaries
+      CALL tra_unswap
       IF( .NOT.Agrif_Root() )    CALL Agrif_Update_Tra( kt )      ! children only
+      CALL tra_swap
 #endif      
 
       ! trends computation
-      IF( l_trdtra ) THEN              ! trend of the Asselin filter (tb filtered - tb)/dt     
+      IF( l_trdtra ) THEN      ! trend of the Asselin filter (tb filtered - tb)/dt     
          DO jk = 1, jpkm1
-            zfact = 1.e0 / r2dt_t(jk)             
-            ztrdt(:,:,jk) = ( tb(:,:,jk) - ztrdt(:,:,jk) ) * zfact
-            ztrds(:,:,jk) = ( sb(:,:,jk) - ztrds(:,:,jk) ) * zfact
+            zfact = 1.e0 / r2dt(jk)             
+            ztrdt(:,:,jk) = ( tsb(:,:,jk,jp_tem) - ztrdt(:,:,jk) ) * zfact
+            ztrds(:,:,jk) = ( tsb(:,:,jk,jp_sal) - ztrds(:,:,jk) ) * zfact
          END DO
-         CALL trd_mod( ztrdt, ztrds, jptra_trd_atf, 'TRA', kt )
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_atf, ztrdt )
+         CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_atf, ztrds )
+         DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds ) 
       END IF
 
       !                        ! control print
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tn, clinfo1=' nxt  - Tn: ', mask1=tmask,   &
-         &                       tab3d_2=sn, clinfo2=       ' Sn: ', mask2=tmask )
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsn(:,:,:,jp_tem), clinfo1=' nxt  - Tn: ', mask1=tmask,   &
+         &                       tab3d_2=tsn(:,:,:,jp_sal), clinfo2=       ' Sn: ', mask2=tmask )
       !
    END SUBROUTINE tra_nxt
 
 
-   SUBROUTINE tra_nxt_fix( kt )
+   SUBROUTINE tra_nxt_fix( kt, cdtype, ptb, ptn, pta, kjpt )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE tra_nxt_fix  ***
@@ -162,8 +193,9 @@
       !!              - swap tracer fields to prepare the next time_step.
       !!                This can be summurized for tempearture as:
-      !!             ztm = (ta+2tn+tb)/4       ln_dynhpg_imp = T
-      !!             ztm = 0                   otherwise
+      !!             ztm = tn + rbcp * [ta -2 tn + tb ]       ln_dynhpg_imp = T
+      !!             ztm = 0                                   otherwise
+      !!                   with rbcp=1/4 * (1-atfp^4) / (1-atfp)
       !!             tb  = tn + atfp*[ tb - 2 tn + ta ]
-      !!             tn  = ta 
+      !!             tn  = ta  
       !!             ta  = ztm       (NB: reset to 0 after eos_bn2 call)
       !!
@@ -171,12 +203,17 @@
       !!              - (ta,sa) time averaged (t,s)   (ln_dynhpg_imp = T)
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
-      !!
-      INTEGER  ::   ji, jj, jk   ! dummy loop indices
-      REAL(wp) ::   ztm, ztf     ! temporary scalars
-      REAL(wp) ::   zsm, zsf     !    -         -
-      !!----------------------------------------------------------------------
-
-      IF( kt == nit000 ) THEN
+      INTEGER         , INTENT(in   )                               ::  kt       ! ocean time-step index
+      CHARACTER(len=3), INTENT(in   )                               ::  cdtype   ! =TRA or TRC (tracer indicator)
+      INTEGER         , INTENT(in   )                               ::  kjpt     ! number of tracers
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  ptb      ! before tracer fields
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  ptn      ! now tracer fields
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  pta      ! tracer trend
+      !!
+      INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
+      LOGICAL  ::   ll_tra_hpg       ! local logical
+      REAL(wp) ::   ztn, ztd         ! local scalars
+      !!----------------------------------------------------------------------
+
+      IF( kt == nit000 )  THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'tra_nxt_fix : time stepping'
@@ -184,68 +221,30 @@
       ENDIF
       !
-      !                                              ! ----------------------- !
-      IF( ln_dynhpg_imp ) THEN                       ! semi-implicite hpg case !
-         !                                           ! ----------------------- !
+      IF( cdtype == 'TRA' )  THEN   ;   ll_tra_hpg = ln_dynhpg_imp    ! active  tracers case  and  semi-implicit hpg    
+      ELSE                          ;   ll_tra_hpg = .FALSE.          ! passive tracers case or NO semi-implicit hpg
+      ENDIF
+      !
+      DO jn = 1, kjpt
          !
-         IF( neuler == 0 .AND. kt == nit000 ) THEN        ! Euler time-stepping at first time-step
-            DO jk = 1, jpkm1                              ! (only swap)
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                                           ! tb <-- tn
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
-                  END DO
+         DO jk = 1, jpkm1
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ztn = ptn(ji,jj,jk,jn)                                    
+                  ztd = pta(ji,jj,jk,jn) - 2. * ztn + ptb(ji,jj,jk,jn)      !  time laplacian on tracers
+                  !
+                  ptb(ji,jj,jk,jn) = ztn + atfp * ztd                       ! ptb <-- filtered ptn 
+                  ptn(ji,jj,jk,jn) = pta(ji,jj,jk,jn)                       ! ptn <-- pta
+                  !
+                  IF( ll_tra_hpg )   pta(ji,jj,jk,jn) = ztn + rbcp * ztd    ! pta <-- Brown & Campana average
                END DO
-            END DO
-         ELSE                                             ! general case (Leapfrog + Asselin filter
-            DO jk = 1, jpkm1
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     ztm = 0.25 * ( ta(ji,jj,jk) + 2.* tn(ji,jj,jk) + tb(ji,jj,jk) )       ! mean t
-                     zsm = 0.25 * ( sa(ji,jj,jk) + 2.* sn(ji,jj,jk) + sb(ji,jj,jk) )
-                     ztf = atfp * ( ta(ji,jj,jk) - 2.* tn(ji,jj,jk) + tb(ji,jj,jk) )       ! Asselin filter on t 
-                     zsf = atfp * ( sa(ji,jj,jk) - 2.* sn(ji,jj,jk) + sb(ji,jj,jk) )
-                     tb(ji,jj,jk) = tn(ji,jj,jk) + ztf                                     ! tb <-- filtered tn 
-                     sb(ji,jj,jk) = sn(ji,jj,jk) + zsf
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                                           ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
-                     ta(ji,jj,jk) = ztm                                                    ! ta <-- mean t
-                     sa(ji,jj,jk) = zsm
-                  END DO
-               END DO
-            END DO
-         ENDIF
-         !                                           ! ----------------------- !
-      ELSE                                           !    explicit hpg case    !
-         !                                           ! ----------------------- !
+           END DO
+         END DO
          !
-         IF( neuler == 0 .AND. kt == nit000 ) THEN        ! Euler time-stepping at first time-step
-            DO jk = 1, jpkm1
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                                           ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
-                  END DO
-               END DO
-            END DO
-         ELSE                                             ! general case (Leapfrog + Asselin filter
-            DO jk = 1, jpkm1
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     ztf = atfp * ( ta(ji,jj,jk) - 2.* tn(ji,jj,jk) + tb(ji,jj,jk) )       ! Asselin filter on t 
-                     zsf = atfp * ( sa(ji,jj,jk) - 2.* sn(ji,jj,jk) + sb(ji,jj,jk) )
-                     tb(ji,jj,jk) = tn(ji,jj,jk) + ztf                                     ! tb <-- filtered tn 
-                     sb(ji,jj,jk) = sn(ji,jj,jk) + zsf
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                                           ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
-                  END DO
-               END DO
-            END DO
-         ENDIF
-      ENDIF
+      END DO
       !
    END SUBROUTINE tra_nxt_fix
 
 
-   SUBROUTINE tra_nxt_vvl( kt )
+   SUBROUTINE tra_nxt_vvl( kt, cdtype, ptb, ptn, pta, kjpt )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE tra_nxt_vvl  ***
@@ -260,7 +259,7 @@
       !!              - swap tracer fields to prepare the next time_step.
       !!                This can be summurized for tempearture as:
-      !!             ztm = (e3t_a*ta+2*e3t_n*tn+e3t_b*tb)   ln_dynhpg_imp = T
-      !!                  /(e3t_a   +2*e3t_n   +e3t_b   )    
-      !!             ztm = 0                                otherwise
+      !!             ztm = ( e3t_n*tn + rbcp*[ e3t_b*tb - 2 e3t_n*tn + e3t_a*ta ] )   ln_dynhpg_imp = T
+      !!                  /( e3t_n    + rbcp*[ e3t_b    - 2 e3t_n    + e3t_a    ] )   
+      !!             ztm = 0                                                       otherwise
       !!             tb  = ( e3t_n*tn + atfp*[ e3t_b*tb - 2 e3t_n*tn + e3t_a*ta ] )
       !!                  /( e3t_n    + atfp*[ e3t_b    - 2 e3t_n    + e3t_a    ] )
@@ -271,11 +270,18 @@
       !!              - (ta,sa) time averaged (t,s)   (ln_dynhpg_imp = T)
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      INTEGER         , INTENT(in   )                               ::  kt       ! ocean time-step index
+      CHARACTER(len=3), INTENT(in   )                               ::  cdtype   ! =TRA or TRC (tracer indicator)
+      INTEGER         , INTENT(in   )                               ::  kjpt     ! number of tracers
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  ptb      ! before tracer fields
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  ptn      ! now tracer fields
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  pta      ! tracer trend
       !!     
-      INTEGER  ::   ji, jj, jk             ! dummy loop indices
-      REAL(wp) ::   ztm , ztc_f , ztf , ztca, ztcn, ztcb   ! temporary scalar
-      REAL(wp) ::   zsm , zsc_f , zsf , zsca, zscn, zscb   !    -         -
-      REAL(wp) ::   ze3mr, ze3fr                           !    -         -
-      REAL(wp) ::   ze3t_b, ze3t_n, ze3t_a, ze3t_f         !    -         -
+      LOGICAL  ::   ll_tra, ll_tra_hpg, ll_traqsr   ! local logical
+      INTEGER  ::   ji, jj, jk, jn              ! dummy loop indices
+      REAL(wp) ::   ztc_a , ztc_n , ztc_b       ! local scalar
+      REAL(wp) ::   ztc_f , ztc_d               !   -      -
+      REAL(wp) ::   ze3t_b, ze3t_n, ze3t_a      !   -      -
+      REAL(wp) ::   ze3t_f, ze3t_d              !   -      -
+      REAL(wp) ::   zfact1, zfact2              !   -      -
       !!----------------------------------------------------------------------
 
@@ -285,101 +291,55 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
       ENDIF
-
-      !                                              ! ----------------------- !
-      IF( ln_dynhpg_imp ) THEN                       ! semi-implicite hpg case !
-         !                                           ! ----------------------- !
-         !
-         IF( neuler == 0 .AND. kt == nit000 ) THEN        ! Euler time-stepping at first time-step
-            DO jk = 1, jpkm1                              ! (only swap)
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                    ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
-                  END DO
+      !
+      IF( cdtype == 'TRA' )  THEN   
+         ll_tra     = .TRUE.           ! active tracers case  
+         ll_tra_hpg = ln_dynhpg_imp    ! active  tracers case  and  semi-implicit hpg
+         ll_traqsr  = ln_traqsr        ! active  tracers case  and  solar penetration
+      ELSE                          
+         ll_tra     = .FALSE.          ! passive tracers case
+         ll_tra_hpg = .FALSE.          ! passive tracers case or NO semi-implicit hpg
+         ll_traqsr  = .FALSE.          ! active  tracers case and NO solar penetration
+      ENDIF
+      !
+      DO jn = 1, kjpt      
+         DO jk = 1, jpkm1
+            zfact1 = atfp * rdttra(jk)
+            zfact2 = zfact1 / rau0
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ze3t_b = fse3t_b(ji,jj,jk)
+                  ze3t_n = fse3t_n(ji,jj,jk)
+                  ze3t_a = fse3t_a(ji,jj,jk)
+                  !                                         ! tracer content at Before, now and after
+                  ztc_b  = ptb(ji,jj,jk,jn) * ze3t_b
+                  ztc_n  = ptn(ji,jj,jk,jn) * ze3t_n
+                  ztc_a  = pta(ji,jj,jk,jn) * ze3t_a
+                  !
+                  ze3t_d = ze3t_a - 2. * ze3t_n + ze3t_b
+                  ztc_d  = ztc_a  - 2. * ztc_n  + ztc_b
+                  !
+                  ze3t_f = ze3t_n + atfp * ze3t_d
+                  ztc_f  = ztc_n  + atfp * ztc_d
+                  !
+                  IF( ll_tra .AND. jk == 1 ) THEN           ! first level only for T & S
+                      ze3t_f = ze3t_f - zfact2 * ( emp_b(ji,jj) - emp(ji,jj) )
+                      ztc_f  = ztc_f  - zfact1 * ( sbc_tsc(ji,jj,jn) - sbc_tsc_b(ji,jj,jn) )
+                  ENDIF
+                  IF( ll_traqsr .AND. jn == jp_tem .AND. jk <= nksr )   &     ! solar penetration (temperature only)
+                     &     ztc_f  = ztc_f  - zfact1 * ( qsr_hc(ji,jj,jk) - qsr_hc_b(ji,jj,jk) ) 
+
+                   ze3t_f = 1.e0 / ze3t_f
+                   ptb(ji,jj,jk,jn) = ztc_f * ze3t_f       ! ptb <-- ptn filtered
+                   ptn(ji,jj,jk,jn) = pta(ji,jj,jk,jn)     ! ptn <-- pta
+                   !
+                   IF( ll_tra_hpg ) THEN        ! semi-implicit hpg (T & S only)
+                      ze3t_d           = 1.e0   / ( ze3t_n + rbcp * ze3t_d )
+                      pta(ji,jj,jk,jn) = ze3t_d * ( ztc_n  + rbcp * ztc_d  )   ! ta <-- Brown & Campana average
+                   ENDIF
                END DO
             END DO
-         ELSE
-            DO jk = 1, jpkm1
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     ze3t_b = fse3t_b(ji,jj,jk)
-                     ze3t_n = fse3t_n(ji,jj,jk)
-                     ze3t_a = fse3t_a(ji,jj,jk)
-                     !                                         ! tracer content at Before, now and after
-                     ztcb = tb(ji,jj,jk) *  ze3t_b   ;   zscb = sb(ji,jj,jk) * ze3t_b
-                     ztcn = tn(ji,jj,jk) *  ze3t_n   ;   zscn = sn(ji,jj,jk) * ze3t_n
-                     ztca = ta(ji,jj,jk) *  ze3t_a   ;   zsca = sa(ji,jj,jk) * ze3t_a
-                     !
-                     !                                         ! Asselin filter on thickness and tracer content
-                     ze3t_f = atfp * ( ze3t_a - 2.* ze3t_n + ze3t_b )
-                     ztc_f  = atfp * ( ztca   - 2.* ztcn   + ztcb   ) 
-                     zsc_f  = atfp * ( zsca   - 2.* zscn   + zscb   ) 
-                     !
-                     !                                         ! filtered tracer including the correction 
-                     ze3fr = 1.e0  / ( ze3t_n + ze3t_f )
-                     ztf   = ze3fr * ( ztcn   + ztc_f  )
-                     zsf   = ze3fr * ( zscn   + zsc_f  )
-                     !                                         ! mean thickness and tracer
-                     ze3mr = 1.e0  / ( ze3t_a + 2.* ze3t_n + ze3t_b )
-                     ztm   = ze3mr * ( ztca   + 2.* ztcn   + ztcb   )
-                     zsm   = ze3mr * ( zsca   + 2.* zscn   + zscb   )
-!!gm mean e3t have to be saved and used in dynhpg  or it can be recomputed in dynhpg !!
-!!gm                 e3t_m(ji,jj,jk) = 0.25 / ze3mr
-                     !                                         ! swap of arrays
-                     tb(ji,jj,jk) = ztf                             ! tb <-- tn + filter
-                     sb(ji,jj,jk) = zsf
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                    ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
-                     ta(ji,jj,jk) = ztm                             ! ta <-- mean t
-                     sa(ji,jj,jk) = zsm
-                  END DO
-               END DO
-            END DO
-         ENDIF
-         !                                           ! ----------------------- !
-      ELSE                                           !    explicit hpg case    !
-         !                                           ! ----------------------- !
-         !
-         IF( neuler == 0 .AND. kt == nit000 ) THEN        ! case of Euler time-stepping at first time-step
-            DO jk = 1, jpkm1                              ! No filter nor thickness weighting computation required
-               DO jj = 1, jpj                             ! ONLY swap
-                  DO ji = 1, jpi
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                                 ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
-                  END DO
-               END DO
-            END DO
-            !                                             ! general case (Leapfrog + Asselin filter)
-         ELSE                                             ! apply filter on thickness weighted tracer and swap
-            DO jk = 1, jpkm1
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     ze3t_b = fse3t_b(ji,jj,jk)
-                     ze3t_n = fse3t_n(ji,jj,jk)
-                     ze3t_a = fse3t_a(ji,jj,jk)
-                     !                                         ! tracer content at Before, now and after
-                     ztcb = tb(ji,jj,jk) *  ze3t_b   ;   zscb = sb(ji,jj,jk) * ze3t_b
-                     ztcn = tn(ji,jj,jk) *  ze3t_n   ;   zscn = sn(ji,jj,jk) * ze3t_n
-                     ztca = ta(ji,jj,jk) *  ze3t_a   ;   zsca = sa(ji,jj,jk) * ze3t_a
-                     !
-                     !                                         ! Asselin filter on thickness and tracer content
-                     ze3t_f = atfp * ( ze3t_a - 2.* ze3t_n + ze3t_b )
-                     ztc_f  = atfp * ( ztca   - 2.* ztcn   + ztcb   ) 
-                     zsc_f  = atfp * ( zsca   - 2.* zscn   + zscb   ) 
-                     !
-                     !                                         ! filtered tracer including the correction 
-                     ze3fr = 1.e0 / ( ze3t_n + ze3t_f )
-                     ztf   =  ( ztcn  + ztc_f ) * ze3fr
-                     zsf   =  ( zscn  + zsc_f ) * ze3fr
-                     !                                         ! swap of arrays
-                     tb(ji,jj,jk) = ztf                             ! tb <-- tn filtered
-                     sb(ji,jj,jk) = zsf
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                    ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
-                  END DO
-               END DO
-            END DO
-         ENDIF
-      ENDIF
+         END DO
+         ! 
+      END DO
       !
    END SUBROUTINE tra_nxt_vvl
